<template>
  <v-form>
    <v-container>
      <v-row>
        <v-col
          cols="12"
          md="4"
        >
          <password-field
            v-model="$v.form.currentPassword.$model"
            required-password
            current-password
          />
        </v-col>

        <v-col
          cols="12"
          md="4"
        >
          <password-field
            v-model="$v.form.newPassword.$model"
            required-password
            new-password
            :error-messages="newPasswordValidations"
          />
        </v-col>

        <v-col
          cols="12"
          md="4"
        >
          <password-confirmation-field
            v-model="$v.form.newPasswordConfirmation.$model"
            required-password-confirmation
            new-password
            :error-messages="newPasswordConfirmationValidations"
          />
        </v-col>

        <v-col
          cols="12"
          class="text-right"
        >
          <update-btn>
            {{ $t('updatePassword') }}
          </update-btn>
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
  import UpdateBtn from './UpdateBtn'
  import { validationMixin } from 'vuelidate'
  import { required, minLength, maxLength, sameAs } from 'vuelidate/lib/validators'

  const formInitialState = {
    currentPassword: '',
    newPassword: '',
    newPasswordConfirmation: '',
  }

  export default {
    name: 'AccessPassword',
    components: {
      UpdateBtn,
    },
    mixins: [validationMixin],
    data () {
      return {
        form: formInitialState,
      }
    },
    validations: {
      form: {
        currentPassword: {},
        newPassword: {
          required,
          minLength: minLength(8),
          maxLength: maxLength(64),
        },
        newPasswordConfirmation: {
          sameAs: sameAs('newPassword'),
        },
      },
    },
    computed: {
      newPasswordValidations () {
        const newPassword = this.$v.form.newPassword
        if (!newPassword.$dirty) {
          return ''
        }
        return !newPassword.required
          ? this.$t('global.validations.required')
          : !newPassword.maxLength
            ? this.$t('global.validations.maxLength', { n: newPassword.$params.maxLength.max })
            : !newPassword.minLength
              ? this.$t('global.validations.minLength', { n: newPassword.$params.minLength.min })
              : ''
      },
      newPasswordConfirmationValidations () {
        const newPasswordConfirmation = this.$v.form.newPasswordConfirmation
        if (!newPasswordConfirmation.$dirty) {
          return ''
        }
        return !newPasswordConfirmation.sameAs
          ? this.$t('global.validations.sameAs')
          : ''
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          currentPassword: 'Senha atual',
          updatePassword: 'Alterar senha',
        },
        'en-US': {
          currentPassword: 'Current password',
          updatePassword: 'Update password',
        },
      },
    },
  }
</script>
